<?php
header('Content-Type: application/json');
require 'config.php'; // Einbinden der Konfigurationsdatei

function logline($text, $wert = "") {
    $logFile = 'logfile.log';
    $logLine = "";

    if ($text == "<H>") {
        $logLine .= "┌────────────────────────────────────────────────────────────────────────┐\n";
        $logLine .= "│ " . str_pad($wert, 71) . " │\n";
        $logLine .= "└────────────────────────────────────────────────────────────────────────┘\n";
    } else {
        $logLine .= str_pad($text, 50) . ": " . $wert . "\n";
    }

    file_put_contents($logFile, $logLine, FILE_APPEND);
}

function openDbf($filename) {
    $dbf = fopen($filename, 'rb+');
    if (!$dbf) {
        logline("Error", "Kann die DBF-Datei nicht öffnen.");
        throw new Exception("Kann die DBF-Datei nicht öffnen.");
    }
    return $dbf;
}

function getDbfHeader($dbf) {
    $header = fread($dbf, 32);
    $data = unpack('VrecordCount/vheaderLength/vrecordLength', substr($header, 4, 8));
    return $data;
}

function deleteRecordFromDbf($filename, $recno) {
    $dbf = openDbf($filename);
    $header = getDbfHeader($dbf);

    $headerLength = $header['headerLength'];
    $recordLength = $header['recordLength'];

    fseek($dbf, $headerLength + ($recno - 1) * $recordLength);
    fwrite($dbf, '*', 1);

    fclose($dbf);

    logline("Datensatz gelöscht", "Record number: $recno");

    echo json_encode(["success" => true, "message" => "Record deleted successfully"]);
}

$data = json_decode(file_get_contents('php://input'), true);
if ($data && isset($data['recno'])) {
    deleteRecordFromDbf(DBF_FILE_PATH, $data['recno']);
} else {
    echo json_encode(["success" => false, "message" => "Invalid input"]);
}
?>
